/*
Copyright (c) Nmap project and its contributors
All rights reserved.

Redistribution and use in source and binary forms, with or without 
modification, are permitted provided that the following conditions 
are met:

 1. Redistributions of source code must retain the above copyright 
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in 
    the documentation and/or other materials provided with the 
    distribution.
 3. Neither the name of Nmap nor the names of its contributors 
    may be used to endorse or promote products derived from this 
    software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT 
 LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
 ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __SCAN_H__
#define __SCAN_H__

#define	STATE_NEW			0
#define STATE_VALIDATED		10
#define STATE_INPROGRESS	20
#define STATE_FINISHED		30
#define STATE_EXECERROR		40
#define STATE_WIP			50
#define STATE_TEMP			-10

#define TYPE_SINGLE			1
#define TYPE_SCHEDULED		2	
#define TYPE_PERIODIC		3
#define TYPE_INHERITED		4
#define TYPE_TEMP			-5


#define RIGHT_MAIL			"MAIL-RESULT"

#define MAXARGS	100
#define MAXARGSIZE 100
#define MAXSCANS	10


typedef struct
{
	int pid;
	int scanid;
} scan_t;

char* find_xmlfilename( const int );
char* find_txtfilename( const int );
int perform_scans();
int can_run();
int wait_scans();
void init_scans();

#endif
